# Copyright (C) 1999 by Juergen Pfeifer <juergen.pfeifer@gmx.net>
# Ada for Linux Team (ALT)
#
# Permission is hereby granted, free of charge, to any person obtaining a  
# copy of this software and associated documentation files (the            
# "Software"), to deal in the Software without restriction, including      
# without limitation the rights to use, copy, modify, merge, publish,      
# distribute, distribute with modifications, sublicense, and/or sell       
# copies of the Software, and to permit persons to whom the Software is    
# furnished to do so, subject to the following conditions:                 
#                                                                          
# The above copyright notice and this permission notice shall be included  
# in all copies or substantial portions of the Software.                   
#                                                                          
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS  
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF               
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.   
# IN NO EVENT SHALL THE ABOVE COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,   
# DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR    
# OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR    
# THE USE OR OTHER DEALINGS IN THE SOFTWARE.                               
#                                                                          
# Except as contained in this notice, the name(s) of the above copyright   
# holders shall not be used in advertising or otherwise to promote the     
# sale, use or other dealings in this Software without prior written       
# authorization.          
#
# ---------------------------------------------------------------------------
#  Author: Juergen Pfeifer <juergen.pfeifer@gmx.net>
# ---------------------------------------------------------------------------

# GNU Ada RPM Packaging for GtkAda
#
%define        PKG_TARGET_OS       Linux
%define        TARGET_OS           linux
%define        TARGET_ARCH         i386
%define        COMPAT_TARGET_ARCH  i386 i486 i586 i686
%define        DEF_USER            bin
%define        DEF_GROUP           bin
%define        CFG_PREFIX          /usr
#
#
%define        BASE_NAME           gnat
%define        GNAT_PKG_NAME       gnat-3.11p
%define        GNAT_BASE_VERSION   3.11
%define        GNAT_PKG_VERSION    1
%define        GNAT_PKG_RELEASE    13
%define        GCC_VERSION         2.8.1
%define        GDB_VERSION         4.17
#
%define        GNAT_VERSION   %{GNAT_BASE_VERSION}p
%define        BASE_VERSION   gcc-%{GCC_VERSION}
#
%define        ADA_ROOT       /lib/gnat
%define        ADA_BASE       %{CFG_PREFIX}%{ADA_ROOT}
#
%define        GNAT_SO_MAJOR  %{GNAT_PKG_VERSION}
%define        GNAT_SO_MINOR  %{GNAT_PKG_RELEASE}
#
%define        RPM_C_FLAGS     -O3 -m486 -fomit-frame-pointer
%define        RPM_ADA_FLAGS   -gnatpn
#
%define        THREADLIBS     -lpthread
#
%define        GNAT_NAME      gnat-%{GNAT_VERSION}
%define        GNAT_SO        %{GNAT_NAME}
%define        GNAT_DIR       %{ADA_BASE}/%{GNAT_NAME}
#
%define        AINC_NAME      adainclude
%define        AINC_DIR       %{ADA_BASE}/%{AINC_NAME}
#
%define        ALIB_NAME      adalib
%define        ALIB_DIR       %{ADA_BASE}/%{ALIB_NAME}
#
%define        ETC_NAME       etc
%define        ETC_DIR        %{ADA_BASE}/%{ETC_NAME}
#
%define        COMPAT_NAME    act_compat-%{GNAT_VERSION}
%define        COMPAT_DIR     %{ADA_BASE}/%{COMPAT_NAME}
#
%define        ASIS_NAME      asis-%{GNAT_VERSION}
%define        ASIS_SO        %{ASIS_NAME}
%define        ASIS_DIR       %{ADA_BASE}/%{ASIS_NAME}
#
%define        GLADE_NAME     glade-%{GNAT_VERSION}
%define        GLADE_DIR      %{ADA_BASE}/%{GLADE_NAME}
#
%define PKG_NAME    GtkAda
%define PKG_VERSION 1.2.2
%define PKG_RELEASE 1
#
# ---------------------------------------------------------------------------
# We restrict the use of this package script at the moment to Intel and
# Linux. For sure there are details (compiler options, shared library
# building) that must be fixed for other architectures and OSes.
#
ExclusiveArch: %{COMPAT_TARGET_ARCH}
ExclusiveOS:   %{PKG_TARGET_OS}
Packager:      Juergen Pfeifer <juergen.pfeifer@gmx.net>
Distribution:  ALT (Ada for Linux Team)
Version:       %{PKG_VERSION}
Release:       %{PKG_RELEASE}
Name:          %{PKG_NAME}
BuildRoot:     /var/tmp/%{PKG_NAME}-%{version}-root
Autoreq:       No
Autoreqprov:   No
# ---------------------------------------------------------------------------
#
%define        LIB_BASE       gtkada
%define        SO_MAJOR       %{GNAT_BASE_VERSION}.1.2
%define        SO_MINOR       2

# ---------------------------------------------------------------------------
# These are the official sources
Source0:       %{name}-%{PKG_VERSION}.tar.gz
#
# This is our patch
Patch0:        %{name}-%{PKG_VERSION}.diff
#  ---------------------------------------------------------------------------
Copyright:     GPL (modified for runtime)
Summary:       Runtime libraries for GtkAda Binding
Summary(de):   Laufzeit-Bibliotheken des GtkAda Bindings
Group:         Libraries
Obsoletes:     %{name}
Provides:      lib%{LIB_BASE}.so.%{SO_MAJOR}
Requires:      %{GNAT_PKG_NAME} >= %{GNAT_PKG_VERSION}
Requires:      gtk+ >= 1.2
Icon:          adarts.gif
Prefix:        %{CFG_PREFIX}
#
%description
This package includes the shared libraries required to run programs compiled
with GtkAda binding support, as long as those programs are not linked
statically.
#
%description -l de
Dieses Paket enthlt die Shared Libraries die zur Ausfhrung von Programmen
bentigt werden, die mit der GtkAda Untersttzung bersetzt wurden, sofern
diese nicht statisch gebunden wurden.
#
#-----------------------------------------------------------------------------
%package devel
Summary:       Ada95 binding to the Gtk+ graphic library
Summary(de):   Ada95 Binding fr die Gtk+ Grafik-Bibliothek
Group:         X11/Libraries
Requires:      %{GNAT_PKG_NAME}-devel >= %{GNAT_PKG_VERSION}
Requires:      %{name} = %{version}
Obsoletes:     %{name}-devel
Icon:          adasmall.gif
Prefix:        %{CFG_PREFIX}
#
%description devel
GtkAda is a set of Ada packages that allows you to write GNU Ada programs 
using the Gtk+ graphics toolkit which is the foundation of the GNOME desktop.
Gtk+ was invented as part of the famous gimp image processing program.
#
%description -l de devel
GtkAda ist eine Sammlung von Ada Paketen die es Ihnen erlauben, GNU Ada 
Programme zu schreiben die den Gtk+ Grafik-Toolkit verwenden, der die Basis 
des GNOME Desktops bildet. Gtk+ wurde als Teil des berhmten gimp 
Bildbearbeitungsprogrammes erfunden.
#-----------------------------------------------------------------------------
%prep
%setup
%patch -p1

%build
#
# Get the name of the Operating System in lower case
OS=%{TARGET_OS}
#
PATH=/usr/bin:/bin:/sbin:/usr/sbin:/usr/local/bin:/usr/local/sbin
if [ "${GNAT_ROOT}" != "" ]; then
   PATH="${GNAT_ROOT}/bin:${PATH}"
fi
export PATH
#
# Create the required directory structure for the binary package
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{CFG_PREFIX}/info
mkdir -p $RPM_BUILD_ROOT%{CFG_PREFIX}/bin
mkdir -p $RPM_BUILD_ROOT%{CFG_PREFIX}/doc
mkdir -p $RPM_BUILD_ROOT%{AINC_DIR}
mkdir -p $RPM_BUILD_ROOT%{ALIB_DIR}
mkdir -p $RPM_BUILD_ROOT%{GNAT_DIR}
mkdir -p $RPM_BUILD_ROOT%{GLADE_DIR}
mkdir -p $RPM_BUILD_ROOT%{ASIS_DIR}
mkdir -p $RPM_BUILD_ROOT%{COMPAT_DIR}
mkdir -p $RPM_BUILD_ROOT%{ETC_DIR}
#
mkdir -p $RPM_BUILD_ROOT%{CFG_PREFIX}/man/man1
#
rm -f config.make
cat >config.make <<EOF
SONAME=lib%{LIB_BASE}.so.%{SO_MAJOR}
EOF
#
CFLAGS="%{RPM_C_FLAGS}" ./configure --prefix=%{CFG_PREFIX} --disable-gtktest
#
make	GNATCC=gnatgcc CFLAGS="%{RPM_C_FLAGS}" \
	GNATFLAGS="%{RPM_C_FLAGS} %{RPM_ADA_FLAGS} -gnatg"
#
#-----------------------------------------------------------------------------
%install
#=============================================================================
OS=%{TARGET_OS}
#
mkdir -p $RPM_BUILD_ROOT/doc/examples
mkdir -p $RPM_BUILD_ROOT/doc/testgtk
mkdir -p $RPM_BUILD_ROOT/doc/docs
#
cp -pf  ANNOUNCE   $RPM_BUILD_ROOT/doc
cp -pf  AUTHORS    $RPM_BUILD_ROOT/doc
cp -pf  COPYING    $RPM_BUILD_ROOT/doc
cp -pf  INSTALL    $RPM_BUILD_ROOT/doc
cp -pf  README     $RPM_BUILD_ROOT/doc
mv -f   docs/*.1   $RPM_BUILD_ROOT%{CFG_PREFIX}/man/man1
cp -prf docs/*     $RPM_BUILD_ROOT/doc/docs
#
cp -prf testgtk/*  $RPM_BUILD_ROOT/doc/testgtk
cp -prf examples/* $RPM_BUILD_ROOT/doc/examples
#
rm -f $RPM_BUILD_ROOT/doc/testgtk/Makefile*
cat > $RPM_BUILD_ROOT/doc/testgtk/Makefile <<EOF
testgtk:
	gnatmake -v -O testgtk

clean:
	rm -f testgtk *.o *.ali core
EOF
#
make prefix=$RPM_BUILD_ROOT%{CFG_PREFIX} \
     incdir=$RPM_BUILD_ROOT%{AINC_DIR}   \
     alidir=$RPM_BUILD_ROOT%{ALIB_DIR}   \
  install
#
cp -pf $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/libgtkada.a \
   $RPM_BUILD_ROOT%{ALIB_DIR}
#
mv $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{LIB_BASE}.so \
   $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{LIB_BASE}.so.%{SO_MAJOR}.%{SO_MINOR}
ln -sf lib%{LIB_BASE}.so.%{SO_MAJOR}.%{SO_MINOR} \
   $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{LIB_BASE}.so.%{SO_MAJOR}
ln -sf lib%{LIB_BASE}.so.%{SO_MAJOR}.%{SO_MINOR} \
   $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{LIB_BASE}.so
ln -sf ../../lib%{LIB_BASE}.so.%{SO_MAJOR} \
   $RPM_BUILD_ROOT%{ALIB_DIR}/lib%{LIB_BASE}.so
#
strip $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/lib%{LIB_BASE}.so.%{SO_MAJOR}.%{SO_MINOR}
#
if [ -d ${RPM_BUILD_ROOT}%{AINC_DIR} ]; then
  find ${RPM_BUILD_ROOT}%{AINC_DIR} -type f -name '*.ad?' -exec chmod 0444 {} \;
fi
if [ -d ${RPM_BUILD_ROOT}%{ALIB_DIR} ]; then
  find ${RPM_BUILD_ROOT}%{ALIB_DIR} -type f -name '*.ali' -exec chmod 0444 {} \;
  find ${RPM_BUILD_ROOT}%{ALIB_DIR} -type f -name '*.a'   -exec chmod 0444 {} \;
fi
if [ -d ${RPM_BUILD_ROOT}%{CFG_PREFIX}/lib ]; then
  find ${RPM_BUILD_ROOT}%{CFG_PREFIX}/lib -type f -name '*.so*' -exec chmod 0755 {} \;
fi
if [ -d ${RPM_BUILD_ROOT}/doc ]; then
  find ${RPM_BUILD_ROOT}/doc -type f -exec chmod 0444 {} \;
  find ${RPM_BUILD_ROOT}/doc -type d -exec chmod 0755 {} \;
fi
#  ---------------------------------------------------------------------------
%pre devel
if [ -f /etc/profile.d/%{BASE_NAME}-rts.sh ]; then
  source /etc/profile.d/%{BASE_NAME}-rts.sh
  if [ ! -z ${GNAT_ROOT} ]; then
    if [ "${GNAT_ROOT}" != "${RPM_INSTALL_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed with --prefix=${GNAT_ROOT}" >&2
      echo "You must use the same prefix with this package." >&2
      exit 1
    fi
  else
    if [ "${RPM_INSTALL_PREFIX}" != "%{CFG_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed without the --prefix option." >&2
      echo "You must do this also with this package." >&2
      exit 1
    fi
  fi
fi
#  ---------------------------------------------------------------------------
%pre
if [ -f /etc/profile.d/%{BASE_NAME}-rts.sh ]; then
  source /etc/profile.d/%{BASE_NAME}-rts.sh
  if [ ! -z ${GNAT_ROOT} ]; then
    if [ "${GNAT_ROOT}" != "${RPM_INSTALL_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed with --prefix=${GNAT_ROOT}" >&2
      echo "You must use the same prefix with this package." >&2
      exit 1
    fi
  else
    if [ "${RPM_INSTALL_PREFIX}" != "%{CFG_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed without the --prefix option." >&2
      echo "You must do this also with this package." >&2
      exit 1
    fi
  fi
fi
#  ---------------------------------------------------------------------------
%post
/sbin/ldconfig
#  ---------------------------------------------------------------------------
%postun
/sbin/ldconfig
#  ---------------------------------------------------------------------------
%files devel
%defattr(-,%{DEF_USER},%{DEF_GROUP})
%doc $RPM_BUILD_ROOT/doc/*
%dir %{CFG_PREFIX}
%dir %{CFG_PREFIX}/lib
%dir %{CFG_PREFIX}/bin
%dir %{CFG_PREFIX}/man
%dir %{CFG_PREFIX}/man/man1
%dir %{ADA_BASE}
%dir %{AINC_DIR}
%dir %{ALIB_DIR}
%{CFG_PREFIX}/bin/*
%{CFG_PREFIX}/man/man1/*
%{AINC_DIR}/*
%{ALIB_DIR}/*
#
#  ---------------------------------------------------------------------------
%files
%defattr(-,%{DEF_USER},%{DEF_GROUP})
%dir %{CFG_PREFIX}
%dir %{CFG_PREFIX}/lib
%{CFG_PREFIX}/lib/lib*.so*
#
#  ---------------------------------------------------------------------------
%clean
rm -rf $RPM_BUILD_ROOT
#  ---------------------------------------------------------------------------
#
%changelog
* Sat May 29 1999 Juergen Pfeifer <juergen.pfeifer@gmx.net>
- Adapted to GtkAda-1.2.2
- Published as Release 1 of Version 1.2.2

* Mon May 10 1999 Juergen Pfeifer <juergen.pfeifer@gmx.net>
- Adapted to GtkAda-1.2.1
- Published as Release 1 of Version 1.2.1

* Thu Apr 08 1999 Juergen Pfeifer <juergen.pfeifer@gmx.net>
- Adapted to GtkAda-1.2.0
- Published as Release 1 of Version 1.2

* Mon Mar 08 1999 Juergen Pfeifer <juergen.pfeifer@gmx.net>
- Improved package dependency description

* Sun Mar 07 1999 Juergen Pfeifer <juergen.pfeifer@gmx.net>
- Publish as Release 1

* Sat Mar 06 1999 Juergen Pfeifer <juergen.pfeifer@gmx.net>
- Build separate runtime and development package. Improve original Makefile.

* Thu Mar 04 1999 Juergen Pfeifer <juergen.pfeifer@gmx.net>
- Created
